<a id="types-aiobotocore-iotfleetwise"></a>

# types-aiobotocore-iotfleetwise

[![PyPI - types-aiobotocore-iotfleetwise](https://img.shields.io/pypi/v/types-aiobotocore-iotfleetwise.svg?color=blue)](https://pypi.org/project/types-aiobotocore-iotfleetwise)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/types-aiobotocore-iotfleetwise.svg?color=blue)](https://pypi.org/project/types-aiobotocore-iotfleetwise)
[![Docs](https://img.shields.io/readthedocs/types-aiobotocore.svg?color=blue)](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_iotfleetwise/)
[![PyPI - Downloads](https://static.pepy.tech/badge/types-aiobotocore-iotfleetwise)](https://pepy.tech/project/types-aiobotocore-iotfleetwise)

![boto3.typed](https://github.com/youtype/mypy_boto3_builder/raw/main/logo.png)

Type annotations for
[aiobotocore.IoTFleetWise 2.6.0](https://boto3.amazonaws.com/v1/documentation/api/latest/reference/services/iotfleetwise.html#IoTFleetWise)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 7.17.2](https://github.com/youtype/mypy_boto3_builder).

More information can be found on
[types-aiobotocore](https://pypi.org/project/types-aiobotocore/) page and in
[types-aiobotocore-iotfleetwise docs](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_iotfleetwise/).

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/youtype/mypy_boto3_builder/raw/main/demo.gif)

- [types-aiobotocore-iotfleetwise](#types-aiobotocore-iotfleetwise)
  - [How to install](#how-to-install)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [How to uninstall](#how-to-uninstall)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Emacs](#emacs)
    - [Sublime Text](#sublime-text)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Literals](#literals)
    - [Type definitions](#type-definitions)
  - [How it works](#how-it-works)
  - [What's new](#what's-new)
    - [Implemented features](#implemented-features)
    - [Latest changes](#latest-changes)
  - [Versioning](#versioning)
  - [Thank you](#thank-you)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

<a id="how-to-install"></a>

## How to install

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `types-aiobotocore` for `IoTFleetWise` service.

```bash
# install with aiobotocore type annotations
python -m pip install 'types-aiobotocore[iotfleetwise]'


# Lite version does not provide session.client/resource overloads
# it is more RAM-friendly, but requires explicit type annotations
python -m pip install 'types-aiobotocore-lite[iotfleetwise]'


# standalone installation
python -m pip install types-aiobotocore-iotfleetwise
```

<a id="how-to-uninstall"></a>

## How to uninstall

```bash
python -m pip uninstall -y types-aiobotocore-iotfleetwise
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `types-aiobotocore[iotfleetwise]` in your environment:

```bash
python -m pip install 'types-aiobotocore[iotfleetwise]'
```

Both type checking and code completion should now work. No explicit type
annotations required, write your `aiobotocore` code as usual.

<a id="pycharm"></a>

### PyCharm

Install `types-aiobotocore-lite[iotfleetwise]` in your environment:

```bash
python -m pip install 'types-aiobotocore-lite[iotfleetwise]'`
```

Both type checking and code completion should now work. Explicit type
annotations **are required**.

Use `types-aiobotocore` package instead for implicit type discovery.

<a id="emacs"></a>

### Emacs

- Install `types-aiobotocore` with services you use in your environment:

```bash
python -m pip install 'types-aiobotocore[iotfleetwise]'
```

- Install [use-package](https://github.com/jwiegley/use-package),
  [lsp](https://github.com/emacs-lsp/lsp-mode/),
  [company](https://github.com/company-mode/company-mode) and
  [flycheck](https://github.com/flycheck/flycheck) packages
- Install [lsp-pyright](https://github.com/emacs-lsp/lsp-pyright) package

```elisp
(use-package lsp-pyright
  :ensure t
  :hook (python-mode . (lambda ()
                          (require 'lsp-pyright)
                          (lsp)))  ; or lsp-deferred
  :init (when (executable-find "python3")
          (setq lsp-pyright-python-executable-cmd "python3"))
  )
```

- Make sure emacs uses the environment where you have installed
  `types-aiobotocore`

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="sublime-text"></a>

### Sublime Text

- Install `types-aiobotocore[iotfleetwise]` with services you use in your
  environment:

```bash
python -m pip install 'types-aiobotocore[iotfleetwise]'
```

- Install [LSP-pyright](https://github.com/sublimelsp/LSP-pyright) package

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `types-aiobotocore[iotfleetwise]` in your environment:

```bash
python -m pip install 'types-aiobotocore[iotfleetwise]'`
```

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `npm i -g pyright`
- Install `types-aiobotocore[iotfleetwise]` in your environment:

```bash
python -m pip install 'types-aiobotocore[iotfleetwise]'
```

Optionally, you can install `types-aiobotocore` to `typings` folder.

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`IoTFleetWiseClient` provides annotations for
`session.create_client("iotfleetwise")`.

```python
from aiobotocore.session import get_session

from types_aiobotocore_iotfleetwise import IoTFleetWiseClient

session = get_session()
async with session.create_client("iotfleetwise") as client:
    client: IoTFleetWiseClient
    # now client usage is checked by mypy and IDE should provide code completion
```

<a id="paginators-annotations"></a>

### Paginators annotations

`types_aiobotocore_iotfleetwise.paginator` module contains type annotations for
all paginators.

```python
from aiobotocore.session import get_session

from types_aiobotocore_iotfleetwise import IoTFleetWiseClient
from types_aiobotocore_iotfleetwise.paginator import (
    GetVehicleStatusPaginator,
    ListCampaignsPaginator,
    ListDecoderManifestNetworkInterfacesPaginator,
    ListDecoderManifestSignalsPaginator,
    ListDecoderManifestsPaginator,
    ListFleetsPaginator,
    ListFleetsForVehiclePaginator,
    ListModelManifestNodesPaginator,
    ListModelManifestsPaginator,
    ListSignalCatalogNodesPaginator,
    ListSignalCatalogsPaginator,
    ListVehiclesPaginator,
    ListVehiclesInFleetPaginator,
)

session = get_session()
async with session.create_client("iotfleetwise") as client:
    client: IoTFleetWiseClient

    # Explicit type annotations are optional here
    # Types should be correctly discovered by mypy and IDEs
    get_vehicle_status_paginator: GetVehicleStatusPaginator = client.get_paginator(
        "get_vehicle_status"
    )
    list_campaigns_paginator: ListCampaignsPaginator = client.get_paginator("list_campaigns")
    list_decoder_manifest_network_interfaces_paginator: ListDecoderManifestNetworkInterfacesPaginator = client.get_paginator(
        "list_decoder_manifest_network_interfaces"
    )
    list_decoder_manifest_signals_paginator: ListDecoderManifestSignalsPaginator = (
        client.get_paginator("list_decoder_manifest_signals")
    )
    list_decoder_manifests_paginator: ListDecoderManifestsPaginator = client.get_paginator(
        "list_decoder_manifests"
    )
    list_fleets_paginator: ListFleetsPaginator = client.get_paginator("list_fleets")
    list_fleets_for_vehicle_paginator: ListFleetsForVehiclePaginator = client.get_paginator(
        "list_fleets_for_vehicle"
    )
    list_model_manifest_nodes_paginator: ListModelManifestNodesPaginator = client.get_paginator(
        "list_model_manifest_nodes"
    )
    list_model_manifests_paginator: ListModelManifestsPaginator = client.get_paginator(
        "list_model_manifests"
    )
    list_signal_catalog_nodes_paginator: ListSignalCatalogNodesPaginator = client.get_paginator(
        "list_signal_catalog_nodes"
    )
    list_signal_catalogs_paginator: ListSignalCatalogsPaginator = client.get_paginator(
        "list_signal_catalogs"
    )
    list_vehicles_paginator: ListVehiclesPaginator = client.get_paginator("list_vehicles")
    list_vehicles_in_fleet_paginator: ListVehiclesInFleetPaginator = client.get_paginator(
        "list_vehicles_in_fleet"
    )
```

<a id="literals"></a>

### Literals

`types_aiobotocore_iotfleetwise.literals` module contains literals extracted
from shapes that can be used in user code for type checking.

Full list of `IoTFleetWise` Literals can be found in
[docs](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_iotfleetwise/literals/).

```python
from types_aiobotocore_iotfleetwise.literals import CampaignStatusType


def check_value(value: CampaignStatusType) -> bool:
    ...
```

<a id="type-definitions"></a>

### Type definitions

`types_aiobotocore_iotfleetwise.type_defs` module contains structures and
shapes assembled to typed dictionaries and unions for additional type checking.

Full list of `IoTFleetWise` TypeDefs can be found in
[docs](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_iotfleetwise/type_defs/).

```python
from types_aiobotocore_iotfleetwise.type_defs import ActuatorTypeDef


def get_value() -> ActuatorTypeDef:
    return {...}
```

<a id="how-it-works"></a>

## How it works

Fully automated
[mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder) carefully
generates type annotations for each service, patiently waiting for
`aiobotocore` updates. It delivers drop-in type annotations for you and makes
sure that:

- All available `aiobotocore` services are covered.
- Each public class and method of every `aiobotocore` service gets valid type
  annotations extracted from `botocore` schemas.
- Type annotations include up-to-date documentation.
- Link to documentation is provided for every method.
- Code is processed by [black](https://github.com/psf/black) and
  [isort](https://github.com/PyCQA/isort) for readability.

<a id="what's-new"></a>

## What's new

<a id="implemented-features"></a>

### Implemented features

- Fully type annotated `boto3`, `botocore`, `aiobotocore` and `aioboto3`
  libraries
- `mypy`, `pyright`, `VSCode`, `PyCharm`, `Sublime Text` and `Emacs`
  compatibility
- `Client`, `ServiceResource`, `Resource`, `Waiter` `Paginator` type
  annotations for each service
- Generated `TypeDefs` for each service
- Generated `Literals` for each service
- Auto discovery of types for `boto3.client` and `boto3.resource` calls
- Auto discovery of types for `session.client` and `session.resource` calls
- Auto discovery of types for `client.get_waiter` and `client.get_paginator`
  calls
- Auto discovery of types for `ServiceResource` and `Resource` collections
- Auto discovery of types for `aiobotocore.Session.create_client` calls

<a id="latest-changes"></a>

### Latest changes

Builder changelog can be found in
[Releases](https://github.com/youtype/mypy_boto3_builder/releases).

<a id="versioning"></a>

## Versioning

`types-aiobotocore-iotfleetwise` version is the same as related `aiobotocore`
version and follows [PEP 440](https://www.python.org/dev/peps/pep-0440/)
format.

<a id="thank-you"></a>

## Thank you

- [Allie Fitter](https://github.com/alliefitter) for
  [boto3-type-annotations](https://pypi.org/project/boto3-type-annotations/),
  this package is based on top of his work
- [black](https://github.com/psf/black) developers for an awesome formatting
  tool
- [Timothy Edmund Crosley](https://github.com/timothycrosley) for
  [isort](https://github.com/PyCQA/isort) and how flexible it is
- [mypy](https://github.com/python/mypy) developers for doing all dirty work
  for us
- [pyright](https://github.com/microsoft/pyright) team for the new era of typed
  Python

<a id="documentation"></a>

## Documentation

All services type annotations can be found in
[aiobotocore docs](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_iotfleetwise/)

<a id="support-and-contributing"></a>

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder/issues/)
repository.
